/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2022 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "spi.h"
#include "tim.h"
#include "usart.h"
#include "gpio.h"
#include "fsmc.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include	"keyled.h"
#include	"lcd.h"
#include	"touch.h"
#include	"stdio.h"
#include	"string.h"
#include "CH395SPI.H"
#include "CH395INC.H"
#include "CH395CMD.H"
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/

/* USER CODE BEGIN PV */

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */
/*洢յ*/
#define recv_buff_len 1500
unsigned char recv_buff[recv_buff_len];

char ch395_version=0;//ȡ汾

unsigned char buf[20];
int ch395_status=0;//ȡж¼
void getNetInterruptData(void);
/**********************************************************************************
* Function Name  : CH395EEPROMTEST
* Description    : EEPROMʾ
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void CH395EEPROMTEST(void)
{
    int addr = 0;//ݵĿʼַ(0-4095)
    uint8_t Buf[100];
    memset(Buf, 0, 100);

    //
//    CH395EEPROMErase();
    //0ַʼд64ֽ(ֻд64ֽ)
//    CH395EEPROMWrite(addr, "19216800111125525525500019216800111219216800100199998888123456789012", 64);

    //0ַʼȡ64ֽ(ֻܶ64ֽ)
    CH395EEPROMRead(addr, Buf, 64);

    printf("Buf=%s\r\n", Buf);
}

/* socket ض*/
uint8_t  SocketIndex = 0; /* Socket (0,1,2,3,4,5,6,7) */
uint8_t  SocketDesIP[4] = {192, 168, 1, 12}; /* Socket ĿIPַ */
uint16_t SocketDesPort   = 6666;           /* Socket ĿĶ˿ */
uint16_t SocketSourPort  = 9897;           /* Socket ض˿ */
uint8_t  SocketSrcIP[4] = {192, 168, 1, 243}; /* Socket ĿIPַ */
uint8_t  SocketGWIPAddr[4] = {192, 168, 1, 1}; 
uint8_t  SocketMASKAddr[4] = {255, 255, 255, 0}; 

/**
* @brief   ʼsocket
* @param   sockindex  Socket(0,1,2,3,4,5,6,7)
* @param   ipaddr  Ŀĵַ
* @param   desprot ĿĶ˿ں
* @param   surprot ض˿ں
* @retval  0:ʼɹ; others:ʼʧ
* @warning None
* @example 
**/
char ch395_socket_udp_init(UINT8 sockindex,UINT8 *ipaddr,UINT16 desprot,UINT16 surprot)
{
    CH395SetSocketProtType(sockindex,PROTO_TYPE_UDP); /* Э */
	
		CH395CMDSetIPAddr(SocketSrcIP);
	CH395CMDSetGWIPAddr(SocketGWIPAddr);
	CH395CMDSetMASKAddr(SocketMASKAddr);
    CH395SetSocketDesIP(sockindex,ipaddr);         		/* Ŀĵַ */         
    CH395SetSocketDesPort(sockindex,desprot);     		/* ĿĶ˿ں */
    CH395SetSocketSourPort(sockindex,surprot);  			/* ض˿ں */
		if(CH395OpenSocket(sockindex) !=0)                /* Socket */
		{
			return 1;
		}
		return 0;
}


/**
* @brief   socket(Ѵ˺ŵȫsocketж)
* @param   sockindex  Socket(0,1,2,3,4,5,6,7)
* @param   None
* @param   None
* @param   None
* @retval  None
* @warning None
* @example 
**/
void ch395_socket_udp_interrupt(UINT8 sockindex)
{
	UINT8  sock_int_socket;
	UINT16 len;
	
	/* ȡsocket ж״̬ */
	sock_int_socket = CH395GetSocketInt(sockindex);
	
	/* ͻУԼдҪ͵ */
	if(sock_int_socket & SINT_STAT_SENBUF_FREE)
	{
		printf("ͻУԼдҪ͵\r\n");
		LCD_ShowString(10,220,234,23,24,"buff please wait...!");
	}
	
	/* ж */
	if(sock_int_socket & SINT_STAT_SEND_OK)                           
	{
		printf("ж\r\n");
	}
	
	/* ж */
	if(sock_int_socket & SINT_STAT_RECV)                              
	{
		LCD_ShowString(10,250,234,23,24,"receive data!");
		len = CH395GetRecvLength(sockindex);/* ȡǰݳ */
		printf("\r\nreceive len = %d\r\n",len);
		if(len == 0)return;
		if(len > recv_buff_len)len = recv_buff_len;
		CH395GetRecvData(sockindex,len,recv_buff);/* ȡ */
		
		/*ѽյݷظUDP*/
		CH395SendData(sockindex,recv_buff,len);
		
		//Ҳʹĺ
		CH395UDPSendTo(recv_buff, len,SocketDesIP, SocketDesPort, sockindex);
		
		/*ʹôڴӡյ*/
//		PutData(&rb_t_usart1_send,recv_buff,len);
//		USART_ITConfig(USART1, USART_IT_TXE, ENABLE);
	}
}

/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */

  /* USER CODE END 1 */

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_FSMC_Init();
  MX_USART1_UART_Init();
  MX_USART2_UART_Init();
  MX_SPI1_Init();
  MX_TIM6_Init();
  /* USER CODE BEGIN 2 */
//  	HAL_TIM_Base_Start_IT(&htim6); //жϷʽTIM6

	ADS7843_Init();//
	LCD_Init();
	POINT_COLOR=RED;      //ûɫΪɫ

	
	//ʼCH395ʹõGPIO
	CH395_PORT_INIT();
	//λ CH395
	CH395_RST();
	
	/*ȡоƬ汾*/
	while((ch395_version = CH395CMDGetVer()) < 0x40)
	{
		printf("CH395CMDGetVer ERR\r\n");
		HAL_Delay(100);
	}
	LCD_ShowString(10,10,234,23,24,"CH395GetVer OK!");	
	
	/*λȡ˵ͨ*/
	while(CH395CMDCheckExist(0x55) != 0xaa)
	{
		printf("\r\nCH395CMDCheck ERR\r\n");
		HAL_Delay(100);
	}
	LCD_ShowString(10,40,234,23,24,"CH395Check OK!");	
	/*ʼģ:ɹ 0 */
	while(CH395CMDInitCH395() != 0)
	{
		printf("\r\nCH395CMDInitCH395 ERR\r\n");
		HAL_Delay(100);
	}
	LCD_ShowString(10,70,234,23,24,"CH395Init OK!");
	/*ʼUDP*/
	while( ch395_socket_udp_init(SocketIndex,SocketDesIP,SocketDesPort,SocketSourPort) != 0)
	{
		printf("\r\nch395_socket_udp_init ERR\r\n");
		HAL_Delay(100);
	}
	
	LCD_ShowString(10,100,234,23,24,"udp_init OK!");
	HAL_Delay(100);
	
		/*ʼģ:ɹ 0 */
	while(CH395CMDInitCH395() != 0)
	{
		printf("\r\nCH395CMDInitCH395 ERR\r\n");
		HAL_Delay(100);
	}
	LCD_ShowString(10,130,234,23,24,"udp_init_again OK!");
	
		CH395GetIPInf(buf);//ȡIP,غ
	printf("IP:%d.%d.%d.%d\r\n",buf[0],buf[1],buf[2],buf[3]);
	printf("GWIP:%d.%d.%d.%d\r\n",buf[4],buf[5],buf[6],buf[7]);
	printf("Mask:%d.%d.%d.%d\r\n",buf[8],buf[9],buf[10],buf[11]);
	printf("DNS1:%d.%d.%d.%d\r\n",buf[12],buf[13],buf[14],buf[15]);
	printf("DNS2:%d.%d.%d.%d\r\n",buf[16],buf[17],buf[18],buf[19]);
	
	LCD_ShowString(10,160,234,23,24,"ch395 all OK!");
	printf("CH395ȫʼɡ\r\n");
  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
	
//	LCD_ShowString(10,10,174,23,24,"Illuminati STM32");	
//	LCD_ShowString(20,40,134,40,16,"Author:Clever");
//	LCD_ShowString(30,80,170,34,24,"4.TFTLCD TEST");
//	LCD_ShowString(50,110,130,34,16,"KEY0:Screen Test");	
//	LCD_ShowString(50,130,130,34,16,"KEY1:Number Test");
//	LCD_ShowString(50,160,120,34,12,"asdfasw:asdfas Test");	
    while (1)
    {
//		printf("this is main\r\n");
		Beep_OFF();
		
//		CH395UDPSendTo("5sdfgasf", 12,SocketDesIP, SocketDesPort, 0);
		//INTŲ͵ƽжԺȥж
		if(Query395Interrupt())
		{
			LCD_ShowString(10,280,234,23,24,"into interrupt!");
			/*ȡж¼*/
			if(ch395_version>=0x44)
			{
				ch395_status = CH395CMDGetGlobIntStatus_ALL();
			}
			else
			{
				ch395_status = CH395CMDGetGlobIntStatus();
			}
			
			/* PHYıж*/
			if(ch395_status & GINT_STAT_PHY_CHANGE)                           
			{
				if(CH395CMDGetPHYStatus() == PHY_DISCONN)//߶Ͽ
				{
					printf("\r\nPHY_DISCONN\r\n");
				}
				else//
				{
					printf("\r\nPHY_CONNECTED\r\n");
//					CH395DHCPEnable(1);//DHCP
				}
			}

			/* DHCP/PPPOEж */
			if(ch395_status & GINT_STAT_DHCP)
			{
				if(CH395GetDHCPStatus() == 0)//DHCP OK
				{
					CH395GetIPInf(buf);//ȡIP,غ
					printf("IP:%d.%d.%d.%d\r\n",buf[0],buf[1],buf[2],buf[3]);
					printf("GWIP:%d.%d.%d.%d\r\n",buf[4],buf[5],buf[6],buf[7]);
					printf("Mask:%d.%d.%d.%d\r\n",buf[8],buf[9],buf[10],buf[11]);
					printf("DNS1:%d.%d.%d.%d\r\n",buf[12],buf[13],buf[14],buf[15]);
					printf("DNS2:%d.%d.%d.%d\r\n",buf[16],buf[17],buf[18],buf[19]);
				}
			}

			/* ɴжϣȡɴϢ */
			if(ch395_status & GINT_STAT_UNREACH){
				CH395CMDGetUnreachIPPT(buf);
				LCD_ShowString(10,280,234,23,24,"ungo!");
			}
			
			/* IPͻжϣ޸CH395 IPʼCH395*/
			if(ch395_status & GINT_STAT_IP_CONFLI){
				LCD_ShowString(10,250,234,23,24,"ip question!");
			}
			/*  SOCK0 ж */
			if(ch395_status & GINT_STAT_SOCK0){
				LCD_ShowString(10,190,234,23,24,"SOCK0 interrupt!");
				ch395_socket_udp_interrupt(SocketIndex);
			}
			/*  SOCK1 ж */
			if(ch395_status & GINT_STAT_SOCK1){

			}
			/*  SOCK2 ж */
			if(ch395_status & GINT_STAT_SOCK2){

			}
			/*  SOCK3 ж */
			if(ch395_status & GINT_STAT_SOCK3){

			}
			
//			
//			if(ch395_version>=0x44)
//			{
//				/*  SOCK4 ж */
//				if(ch395_status & GINT_STAT_SOCK4){

//				}
//				/*  SOCK5 ж */
//				if(ch395_status & GINT_STAT_SOCK5){

//				}
//				/*  SOCK6 ж */
//				if(ch395_status & GINT_STAT_SOCK6){

//				}
//				/*  SOCK7 ж */
//				if(ch395_status & GINT_STAT_SOCK7){

//				}
//			}
		}
		
//        KEYS curkey = ScanPressedKey(KEY_WAIT_ALWAYS);
//        switch(curkey)
//        {
//			case KEY_DOWN:
//				LED1_Toggle();
//				break;
//			case KEY_UP:
//				break;
//			case KEY_LEFT:
//				break;
//			case KEY_RIGHT:
//				LED2_Toggle();
//				break;
//			case KEY_RE:
//				LED3_Toggle();
//				break;
//			case KEY_OK:
//				LED4_Toggle();
//				Beep_Toggle();
//				break;
//			case KEY_NONE:
//				break;
//        }
//		HAL_Delay(200);
//		LED4_Toggle();
//		HAL_Delay(200);
//		LED4_Toggle();
    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */
    }
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Initializes the RCC Oscillators according to the specified parameters
  * in the RCC_OscInitTypeDef structure.
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.HSEPredivValue = RCC_HSE_PREDIV_DIV1;
  RCC_OscInitStruct.HSIState = RCC_HSI_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLMUL = RCC_PLL_MUL9;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }

  /** Initializes the CPU, AHB and APB buses clocks
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV2;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_2) != HAL_OK)
  {
    Error_Handler();
  }
}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
    /* User can add his own implementation to report the HAL error return state */
    __disable_irq();
    while (1)
    {
    }
  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
    /* User can add his own implementation to report the file name and line number,
       ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */
