#ifndef KEYLED_H_
#define KEYLED_H_

#include	"main.h"   //在main.h中定义了Keys和LEDs的Labels宏

/*  这些宏在main.h中定义，在CubeMX中定义引脚的Label自动生成的宏定义
#define KeyOk_Pin GPIO_PIN_13
#define KeyOk_GPIO_Port GPIOC
#define KeyOk_EXTI_IRQn EXTI15_10_IRQn
#define LED1_Pin GPIO_PIN_6
#define LED1_GPIO_Port GPIOF
#define LED2_Pin GPIO_PIN_7
#define LED2_GPIO_Port GPIOF
#define LED3_Pin GPIO_PIN_8
#define LED3_GPIO_Port GPIOF
#define LED4_Pin GPIO_PIN_9
#define LED4_GPIO_Port GPIOF
#define KeyRe_Pin GPIO_PIN_0
#define KeyRe_GPIO_Port GPIOA
#define KeyRe_EXTI_IRQn EXTI0_IRQn
#define Beep_Pin GPIO_PIN_10
#define Beep_GPIO_Port GPIOB
#define KeyDown_Pin GPIO_PIN_8
#define KeyDown_GPIO_Port GPIOA
#define KeyDown_EXTI_IRQn EXTI9_5_IRQn
#define KeyRight_Pin GPIO_PIN_3
#define KeyRight_GPIO_Port GPIOD
#define KeyRight_EXTI_IRQn EXTI3_IRQn

 */

//表示4个按键的枚举类型
typedef enum {
	KEY_NONE=0,		//没有按键被按下
	KEY_LEFT,		//KeyLeft被按下
	KEY_RIGHT,		//KeyRight被按下
	KEY_UP,			//KeyUp被按下
	KEY_DOWN,		//KeyDown被按下
	KEY_RE,			//KeyRE取消被按下
	KEY_OK			//KeyOK被按下
}KEYS;

#define		KEY_WAIT_ALWAYS		0	//作为函数ScanKeys()的一种参数，表示一直等待按键输入
//轮询方式扫描按键，timeout=KEY_WAIT_ALWAYS表示一直扫描，否是等待时间timeout, 延时单位ms
KEYS  ScanPressedKey(uint32_t timeout);


#ifdef	LED1_Pin		//LED1的控制
	#define	 LED1_Toggle()	HAL_GPIO_TogglePin(LED1_GPIO_Port, LED1_Pin)    //输出翻转

	#define	 LED1_ON()		HAL_GPIO_WritePin(LED1_GPIO_Port, LED1_Pin, GPIO_PIN_RESET)  //输出0，亮

	#define	 LED1_OFF()		HAL_GPIO_WritePin(LED1_GPIO_Port, LED1_Pin, GPIO_PIN_SET)  //输出1，灭
#endif


#ifdef	LED2_Pin	//LED2的控制
	#define	 LED2_Toggle()	HAL_GPIO_TogglePin(LED2_GPIO_Port, LED2_Pin)    //输出翻转

	#define	 LED2_ON()		HAL_GPIO_WritePin(LED2_GPIO_Port, LED2_Pin, GPIO_PIN_RESET)  //输出0，亮

	#define	 LED2_OFF()		HAL_GPIO_WritePin(LED2_GPIO_Port, LED2_Pin, GPIO_PIN_SET)  //输出1，灭
#endif

#ifdef	LED3_Pin	//LED2的控制
	#define	 LED3_Toggle()	HAL_GPIO_TogglePin(LED3_GPIO_Port, LED3_Pin)    //输出翻转

	#define	 LED3_ON()		HAL_GPIO_WritePin(LED3_GPIO_Port, LED3_Pin, GPIO_PIN_RESET)  //输出0，亮

	#define	 LED3_OFF()		HAL_GPIO_WritePin(LED3_GPIO_Port, LED3_Pin, GPIO_PIN_SET)  //输出1，灭
#endif

#ifdef	LED4_Pin	//LED2的控制
	#define	 LED4_Toggle()	HAL_GPIO_TogglePin(LED4_GPIO_Port, LED4_Pin)    //输出翻转

	#define	 LED4_ON()		HAL_GPIO_WritePin(LED4_GPIO_Port, LED4_Pin, GPIO_PIN_RESET)  //输出0，亮

	#define	 LED4_OFF()		HAL_GPIO_WritePin(LED4_GPIO_Port, LED4_Pin, GPIO_PIN_SET)  //输出1，灭
#endif


#ifdef	Beep_Pin		//蜂鸣器的控制
	#define	 Beep_Toggle()	HAL_GPIO_TogglePin(Beep_GPIO_Port, Beep_Pin)  //输出翻转

	#define	 Beep_ON()		HAL_GPIO_WritePin(Beep_GPIO_Port, Beep_Pin, GPIO_PIN_RESET)  //输出0，蜂鸣器响

	#define	 Beep_OFF()		HAL_GPIO_WritePin(Beep_GPIO_Port, Beep_Pin, GPIO_PIN_SET)  //输出1蜂鸣器不响
#endif




#endif /* KEYLED_H_ */
