#include "touch.h"
#include "lcd.h"

#define	CHX 	0x90//0x90 	//ͨY+ѡ	//0x94
#define	CHY 	0xD0//0xd0	//ͨX+ѡ	//0xD4

void HAL_GPIO_EXTI_Callback(uint16_t GPIO_Pin)
{
	if(GPIO_Pin == GPIO_PIN_7)
	{
		ARMJISHU_TouchScreen_ADS7843();
	}
}

//ADS7843IOƿ
void ADS7843_Init(void)
{
//    ADS7843_CS_config();     // ʹLCD
    ADS7843_CS_HIGH() ;     // رLCD
//    SPI1_Config();
//    SPI1_Init_For_Byte();
    SPI1_MOSI_HIGH();
    SPI1_SCK_LOW();
//    ADS7843_INT_config();
//    ADS7843_INT_EXIT_Init();
//    ADS7843_InterruptConfig();
}

uint16_t _AD2Y(uint16_t adx) //240
{
  uint16_t sx=0;
  int r = adx - 200;
  r *= 240;
  sx=r / (4000 - 280);
  if (sx<=0 || sx>240)
    return 0;
  return sx;
}


uint16_t _AD2X(uint16_t ady) //320
{
  uint16_t sy=0;
  int r = ady - 260;
  r *= 320;
  sy=r/(3960 - 360);
  if (sy<=0 || sy>320)
    return 0;
  return sy;
}


static void ADS7843_SPI_Start( void )
{
    ADS7843_CS_HIGH();
    SPI1_MOSI_HIGH();
    SPI1_SCK_LOW();
    ADS7843_CS_LOW();	      		//оƬ
}

/*=====================================================================*/
static void SPI_MOSI(uint8_t data)
{
    if(data)
        SPI1_MOSI_HIGH();
    else
        SPI1_MOSI_LOW();
}


static void ADS7843_WrCmd(uint8_t cmd)
{
    uint8_t buf, i;

    for( i = 0; i < 8; i++ )
    {
        buf = (cmd >> (7-i)) & 0x1 ;	//MSBǰ,LSBں
        SPI_MOSI(buf);	 	//ʱDIN
        SPI1_SCK_HIGH();			//ʱ壬һ8
        SPI1_SCK_LOW();			//ʼ
    }
	
}

/*=====================================================================*/
static uint16_t ADS7843_Read(void)
{
	uint16_t buf = 0 ;
	uint8_t i;

    SPI1_SCK_HIGH(); //wait busy
	SPI1_SCK_LOW();	
	for( i = 0; i < 12; i++ )
	{
		buf = buf << 1 ;
		SPI1_SCK_HIGH();
		if ( SPI1_MISO_READ() )	
		{
			buf = buf + 1 ;
		}
		SPI1_SCK_LOW();			
	}

	for( i = 0; i < 3; i++ )
	{
		SPI1_SCK_HIGH();
		SPI1_SCK_LOW();			
	}
    
	return( buf ) ;
}


#define  times  4
static void ADS7843_Rd_Addata(uint16_t *X_Addata,uint16_t *Y_Addata)
{
	uint16_t		i,j,k,x_addata[times],y_addata[times];
    
	for(i=0;i<times;i++)					//4.
	{
	    ADS7843_SPI_Start();
		ADS7843_WrCmd( CHX ) ;
		y_addata[i] = ADS7843_Read() ;
        ADS7843_CS_HIGH(); 

	    ADS7843_SPI_Start();
		ADS7843_WrCmd( CHY ) ;
		x_addata[i] = ADS7843_Read() ;
        ADS7843_CS_HIGH(); 
	}

	for(i=0;i<times;i++)
	{
    	for(j=times;j<times-1;j++)
    	{
           if(x_addata[j] > x_addata[i])
            {
                k = x_addata[j];
                x_addata[i] = x_addata[j];
                x_addata[j] = k;
            }
         }
    }

	for(i=0;i<times;i++)
	{
    	for(j=times;j<times-1;j++)
    	{
           if(y_addata[j] > y_addata[i])
            {
                k = y_addata[j];
                y_addata[i] = y_addata[j];
                y_addata[j] = k;
            }
         }
    }
	
	*X_Addata=(x_addata[1] + x_addata[2]) >> 1;
	*Y_Addata=(y_addata[1] + y_addata[2]) >> 1;

}


uint16_t distence(uint16_t data1,uint16_t data2)
{
    if((data1 > data2) && (data1 > data2 + 10))
    {
        return 0;
    }
    if((data2 > data2) && (data2 > data2 + 10))
    {
        return 0;
    }
    return 1;    
}

static void LCD_BIG_POINT(uint16_t xScreen, uint16_t yScreen)
{
	LCD_Fast_DrawPoint(xScreen, yScreen, MAGENTA);
	LCD_Fast_DrawPoint(xScreen-1, yScreen, MAGENTA);
	LCD_Fast_DrawPoint(xScreen+1, yScreen, MAGENTA);
	LCD_Fast_DrawPoint(xScreen, yScreen-1, MAGENTA);
	LCD_Fast_DrawPoint(xScreen, yScreen+1, MAGENTA);
	LCD_Fast_DrawPoint(xScreen-1, yScreen-1, MAGENTA);
	LCD_Fast_DrawPoint(xScreen-1, yScreen+1, MAGENTA);
	LCD_Fast_DrawPoint(xScreen+1, yScreen-1, MAGENTA);
	LCD_Fast_DrawPoint(xScreen+1, yScreen+1, MAGENTA);

}
 
  
void ARMJISHU_TouchScreen_ADS7843(void)
{
	uint16_t xdata, ydata;
	uint32_t xScreen, yScreen;

	static uint16_t sDataX,sDataY;
    
 // printf("\n\r ARMJISHU_TouchScreen_ADS7843 \n\r");
	ADS7843_Rd_Addata(&xdata, &ydata);
	xScreen = _AD2X(ydata);
	yScreen = _AD2Y(xdata);

   //xScreen = 320 - ((ydata*320)>>12);
   //yScreen = (xdata*240)>>12;

 
    printf("\n\r (0x%x, 0x%x), (%d, %d)", xdata, ydata, xScreen, yScreen);
	if((xScreen>1)&&(yScreen>1)&&(xScreen<320-1)&&(yScreen<240-1))
	{
		printf("\n\r%d,%d", xScreen, yScreen);
		if((GPIO_ADS7843_INT_VALID) && distence(sDataX,xScreen) && distence(sDataY,yScreen))
		{
			 LCD_BIG_POINT(xScreen, yScreen);
		}
		sDataX = xScreen;
		sDataY = yScreen;
	}
    
}

